#include <iostream>
#include <list>
#include <string>
#include <type_traits>
#include <vector>

template <typename Container>
typename std::enable_if<
            std::is_arithmetic_v<typename Container::value_type>,
            typename Container::value_type>::type
summe(const Container& cont)
{
  typename Container::value_type ergebnis{};
  for (auto wert : cont) {
    ergebnis += wert;
  }
  return ergebnis;
}

int main()
{
  const std::vector<int> vektor{3, 6, 8, 9, 1, 3, 0};
  std::cout << "Summe vector<int>  = " << summe(vektor) << '\n';
  const std::list<double> liste{3, 6, 8, 9, 1, 3, 0};
  std::cout << "Summe list<double> = " << summe(liste) << '\n';

  const std::list<std::string> strings{"abc", "def"};
  // Fehler:
  // std::cout << "Summe list<string> = " << summe(strings) << '\n';
}
