#include <future>
#include <iostream>
#include <thread>

void summe(int n, std::promise<int> pr) 
{
  int ergebnis {0};
  for (int i = 1; i <= n; ++i) {
    ergebnis += i;
  }
  // lange Berechnungszeit simulieren
  std::this_thread::sleep_for(std::chrono::seconds(2));
  pr.set_value(ergebnis);                    // future informieren
}

int main() 
{
  std::promise<int> prom;
  auto futur = prom.get_future();
  std::jthread t(summe, 10, std::move(prom));
  std::cout << "Auf Ende der Berechnung warten..." << std::endl;
  std::cout << "Ergebnis: " << futur.get() << '\n';
}

