#include <boost/asio.hpp>
#include <ctime>
#include <iostream>
#include <string>
#include <string_view>
using boost::asio::ip::udp;
using namespace std;

string getZeitstring(string_view format)
{
  constexpr int maximum{80};
  string buf(maximum, '\0');
  time_t jetzt = time(nullptr);
  if (format[1] == 's') {     // Sonderbehandlung für %s, das nicht jeder Compiler kennt
    auto pos{maximum};
    while (jetzt > 0) {                      // Zahl > 0  umwandeln
      buf[--pos] = jetzt % 10 + '0';
      jetzt /= 10;
    }
    return buf.substr(pos);
  }
  else {                           // Umwandlung je nach Format-String mit strftime()
    tm* z = localtime(&jetzt);
    strftime(buf.data(), maximum, format.data(), z);
    return buf;
  }
}

int main(int argc, char* argv[])
{
  if (argc != 2) {
    cout << "Gebrauch: " << argv[0] << " <port>\n";
    return 1;
  }
  boost::asio::io_service ioService;
  unsigned short port = atoi(argv[1]);
  udp::socket socket(ioService, udp::endpoint(udp::v4(), port));
  while (true) {          // Abbruch mit Strg+C
    cout << "lauschen  an Port " << port << " ... (Abbruch mit Strg+C)\n";
    boost::asio::ip::udp::endpoint entfernt;
    char daten[256] {0};
    socket.receive_from(boost::asio::buffer(daten), entfernt);
    string_view format = "%c";
    // nur erstes Byte ist relevant
    switch (daten[0]) {
    case '1': format = "%c";                     break;
    case '2': format = "%A, %d. %B %Y, %X Uhr";  break;
    case '3': format = "%X";                     break;
    case '4': format = "%s";                     break;
    }
    auto zeitstring = getZeitstring(format);
    socket.send_to(boost::asio::buffer(zeitstring.data(), 
                               zeitstring.length() + 1), entfernt);
  }
}


