#include <Random.h>
#include <algorithm>
#include <cmath>                             // fabs()
#include <showContainer.h>
#include <vector>
using namespace std;

class VergleichMitToleranz {
public:
  VergleichMitToleranz(double e) 
  : eps(e) 
  {}
  bool operator()(double x, double y) { return fabs(x - y) < eps; }

private:
  double eps;
};

int main()
{
  vector<double> v1(8);
  vector<double> v2(8);
  Random zufall(100);
  for (int i = 0; i < ssize(v1); ++i) {
    v1[i] = i + zufall() / 10000.0;
    v2[i] = i + zufall() / 10000.0;
  }
  showContainer(v1);          // Anzeige
  showContainer(v2);

  // Prüfung mit Iterator Paar wo
  auto wo = mismatch(v1.begin(), v1.end(), v2.begin(), 
                     VergleichMitToleranz(0.01));  // Schwellenwert
  if (wo.first == v1.end()) {
    cout << "Inhalt der Container stimmt innerhalb der Toleranz überein.\n";
  }
  else {
    cout << "Der erste Unterschied (" << *wo.first << " != "
         << *wo.second << ") wurde an Position "
         << (wo.first - v1.begin()) << " gefunden.\n";
  }
}

