#include <cctype>
#include <fstream>
#include <iostream>
#include <locale>
#include <map>
#include <set>
#include <showContainer.h>
#include <string>
// Test fr Locale de_DE: Mucke Mcke Mae Masse

/* Diese Datei ist im ISO 8859-1 Format abgespeichert, sodass
Umlaute nur einem Byte entsprechen.
Konvertierung nach UTF-8 bewirkt, dass der obige Test fehlschlgt!
Zur korrekten Darstellung muss das Terminal auch auf ISO 8859-1 eingestellt sein.
*/

using namespace std;
int main(int argc, char* argv[])
{
  if (argc == 1) {
    cout << "Gebrauch: " << argv[0]
         << " Dateiname [locale]\nBeispiele (vorgegebene Locale: C)\n"
         << argv[0] << " datei de_DE\n" << argv[0] << " datei\n";
    return 0;
  }
  ifstream quelle(argv[1]);
  if (!quelle.good()) {
    cout << argv[1] << " nicht gefunden!\n";
    return 1;
  }

  if (argc == 3) {
    locale::global(locale(argv[2]));          // ggf. global setzen
                // fr jeden folgenden Aufruf des locale()-Konstruktors
  }
  
  map<string, set<int>, locale> bezeichnerZeilenMap;

  int zeilennr{1};
  while (quelle.good()) {
    char c{'\0'};
    // Anfang des Bezeichners finden
    while (quelle.good() && !(isalpha(c) || '_' == c)) {
      quelle.get(c);
      if (c == '\n') {
        ++zeilennr;
      }
    }
    if (quelle.good()) {
      string bezeichner(1, c);
      // Rest des Bezeichners einsammeln
      while (quelle.good() && (isalnum(c) || '_' == c)) {
        quelle.get(c);
        if (isalnum(c) || '_' == c)
          bezeichner += c;
      }
      quelle.putback(c);                                           // zurck an den Eingabestrom
      if (c) {                                                     // Bezeichner gefunden?
        bezeichnerZeilenMap[bezeichner].insert(zeilennr);          // Eintrag
      }
    }
  }

  for (const auto& mapEintrag : bezeichnerZeilenMap) {
    cout << mapEintrag.first;                            // Bezeichner
    cout.width(20 - mapEintrag.first.length());          // Position bis : einstellen
    cout << ": ";
    showContainer(mapEintrag.second);          // Zeilennummern
  }
}

