#include <iostream>
#include <locale>
#include <string>
#include <type_traits>                      // is_signed
using namespace std;
int main()
{
  locale loc;
  cout << "loc.name()= " << loc.name() << '\n';
  locale dt("de_DE");
  cout << "dt.name()= " << dt.name() << '\n';
  locale vorher = locale::global(dt);       // dt fr alles setzen

  string s("");
  cout.imbue(dt);
  if (s.length() > 7) {
    cerr << "FEHLER: DIESES PROGRAMM IST NICHT in ISO 8859 gespeichert"
            " und wird nicht wie beabsichtigt funktionieren! Abbruch!\n";
    return 1;
  }
  cout << "\nProgramm funktioniert nur richtig bei auf ISO 8859"
          " eingestellter Konsole! \n";
  for (unsigned int i = 0; i < s.length(); ++i) {
    cout << "Zeichen " << i << ": " << s[i] << "   ";
    // ggf. Korrektur fr signed char
    int intwert = static_cast<int>(static_cast<unsigned char>(s[i]));
    cout << intwert << '\n';
  }
  for (auto c : s) {
    cout << toupper(c, dt) << tolower(c, dt) << " ";
  }
  for (auto& c : s) {
    c = toupper(c, dt);
  }
  cout << "\nNach toupper: " << s << '\n';
  // Andere Mglichkeit, jetzt mit tolower:
  use_facet<ctype<char>>(dt).tolower(&s[0], s.c_str() + s.length());
  cout << "Nach tolower: " << s << '\n';
}

// ISO 8859-1: Bits 0-127 wie ASCII reicht fr sehr viele Sprachen aus, 
// hat aber kein Euro-Symbol
//   196 0xC4      228 0xE4
//   214 0xD6      246 0xF6
//   220 0xDC      252 0xFC
//   223 0xDF
// Euro ist 164 0xA4 bei ISO 8859-15


