#ifndef GRAPHOBJ_H
#define GRAPHOBJ_H
#include <Ort.h>                            // enthält #include<iostream>

class GraphObj {                            // Variante 2
public:
  GraphObj(Ort einOrt)                      // allgemeiner Konstruktor
      : referenzkoordinaten{einOrt}
  { }

  virtual ~GraphObj() = default;            // virtueller Destruktor
  GraphObj(const GraphObj&) = delete;       // Regel der großen Drei, siehe Seite 253
  GraphObj& operator=(const GraphObj&) = delete;          // dito

  auto bezugspunkt() const { return referenzkoordinaten; }  // Bezugspunkt ermitteln

  auto bezugspunkt(Ort nO)  // alten Bezugspunkt ermitteln und gleichzeitig neuen wählen
  {
    Ort temp{referenzkoordinaten};
    referenzkoordinaten = nO;
    return temp;
  }

  // Koordinatenabfrage
  auto getX() const { return referenzkoordinaten.getX(); }
  auto getY() const { return referenzkoordinaten.getY(); }

  // rein virtuelle Methoden
  virtual double flaeche() const = 0;
  virtual void zeichnen() const = 0;

private:
  Ort referenzkoordinaten;
};

// Standardimplementierung einer rein virtuellen Methode
inline void GraphObj::zeichnen() const { std::cout << "Zeichnen: "; }

// Die Entfernung zwischen 2 GraphObj-Objekten ist hier als Entfernung
// ihrer Bezugspunkte (überladene Funktion) definiert.
inline auto entfernung(const GraphObj& g1, const GraphObj& g2)
{
  return entfernung(g1.bezugspunkt(), g2.bezugspunkt());
}
#endif


