#include <iostream>

class Basis {
public:
  virtual ~Basis() = default;
  Basis() = default;
  Basis(const Basis&) = delete;
  Basis& operator=(const Basis&) = delete;
};

class Abgeleitet : public Basis {
public:
  void f() { }
};

Abgeleitet* g(Basis* pB)                  // g() benutzt f()
{ 
  Abgeleitet* pA = dynamic_cast<Abgeleitet*>(pB);
  if (pA) {                               // Null-Zeiger bei Scheitern des dynamic_cast
    pA->f();                              // Abgeleitet::f()
  }
  return pA;
}

int main()
{
  Basis einB;
  Abgeleitet einA;
  Basis* pBB = &einB;
  Basis* pBA = &einA;
  Abgeleitet* pErgebnis;
  // Durch den folgenden Aufruf von g() wird in  g() Abgeleitet::f() ausgeführt, 
  // weil pBA auf ein Abgeleitet-Objekt zeigt. pErgebnis zeigt auf einA:
  pErgebnis = g(pBA);
  // Abgeleitet::f() wird unten  nicht ausgeführt, weil pB in g() auf ein Basis-Objekt
  //  zeigt. pErgebnis ist undefiniert(!), weil der static_cast ungeeignet ist:
  // Der dynamische Typ des per Zeiger übergebenen Objekts ist nicht vom Typ Abgeleitet.
  pErgebnis = g(pBB);
}

