#ifndef MATRIX_T
#define MATRIX_T
#include <iostream>
#include <vector>

template <typename T> 
class Matrix {
public:
  Matrix(int zeilen = 1, int spalten = 1, const T& init = T()) 
    : daten(zeilen, std::vector<T>(spalten, init)) 
  { 
    if(zeilen < 1 || spalten < 1) {
      throw std::logic_error("Zeilen-/Spaltenzahl muss > 0 sein!");
    }
  }
  int zeilen() const { return daten.size(); } 
  int spalten() const { return daten[0].size(); } 

  const auto& operator[](int z) const { return daten[z]; } // zum lesen
  auto& operator[](int z) { return daten[z]; }             // zum ändern
private:
  std::vector<std::vector<T>> daten;
};

template <typename T> 
void print(const Matrix<T>& m) 
{
  for (int i = 0; i < m.zeilen(); ++i) {
    for (int j = 0; j < m.spalten(); ++j) {
      std::cout << m[i][j] << ' ';
    }
    std::cout << '\n';
  }
  std::cout << '\n';
}
#endif
