#ifndef B_H
#define B_H
#include "A.h"

class B : public A {
public:
  B(int a_, int b_)
      : A(a_),          // Oberklassenkonstruktor
        b{b_}
  {          // lokale Daten
  }

  B(const B&) = default;

  virtual B& assign(const A& rhs) override
  {
    std::cout << "virtual B& B::assign=(const A&)\n";
    //B temp(dynamic_cast<const B&>(rhs));
    B temp(static_cast<const B&>(rhs));
    swap(temp);
    return *this;
  }

  B& operator=(const B& rhs)
  {
    std::cout << "B& operator=(const B& rhs)\n";
    return assign(rhs);
  }

  virtual void ausgabe() const override
  {
    A::ausgabe();
    std::cout << "B.b = " << b << ' ';
  }

  void swap(B& rhs)
  {
    A::swap(rhs);                 // Oberklassendaten
    std::swap(b, rhs.b);          // lokale Daten
  }
protected:
  virtual bool isEqual(const A& arg) const override
  {
    std::cout << "B::isEqual(const A& arg)\n";
    return A::isEqual(arg) && b == static_cast<const B&>(arg).b;
  }

private:
  int b;
};
#endif          // B_H
