#include "../2/ProfessorIn.h"
#include "../2/StudentIn.h"
#include <iostream>
#include <memory>
#include <typeinfo>
#include <vector>
using namespace std;

int main()
{
  vector<shared_ptr<Person>> diePersonen;
  diePersonen.push_back(make_shared<StudentIn>("Herder", "Johann Gottfried", "635374"));
  diePersonen.push_back(make_shared<ProfessorIn>("Kant", "Immanuel", "Philosophie"));
  diePersonen.push_back(make_shared<StudentIn>("von Schön", "Theodor", "123429"));
  cout << "toString() ergibt:\n";
  for (const auto& personPtr : diePersonen) {          // Referenz!
    cout << personPtr->toString() << '\n';
  }

  cout << "Die Matrikelnummern mit dynamic_pointer_cast:\n";
  for (auto personPtr : diePersonen) {
    cout << personPtr->getVorname() << ": ";
    auto studptr{dynamic_pointer_cast<StudentIn>(personPtr)};
    if (studptr) {
      cout << studptr->getMatrikelnummer() << '\n';
    }
    else {
      cout << " hat keine Matrikelnummer.\n";
    }
  }

  cout << "\nDie Matrikelnummern mit typeid:\n";
  for (auto personPtr : diePersonen) {
    cout << personPtr->getVorname();
    if (typeid(StudentIn) == typeid(*personPtr)) {
      //auto studptr{dynamic_pointer_cast<StudentIn>(personPtr)};
      auto studptr{static_cast<StudentIn*>(personPtr.get())};
      cout << ": " << studptr->getMatrikelnummer() << '\n';
    }
    else {
      cout << " (interner Typ: " << typeid(*personPtr).name() << ") hat keine Matrikelnummer.\n";
    }
  }
}
